-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 4.1.08 of the CMF schema. Migration code to be applied on top of the
-- previous version.
--

update SCHEMA_VERSION set VERSION=04108;
--
-- Add default value to optimistic lock column
--

alter table HOSTS
    modify OPTIMISTIC_LOCK_VERSION default 0;

alter table SERVICES
    modify OPTIMISTIC_LOCK_VERSION default 0;

alter table CONFIG_CONTAINERS
    modify OPTIMISTIC_LOCK_VERSION default 0;


--
-- Add optimistic lock version for all entities that lack it
--

alter table ROLES
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_ROLE_OPT_LOCK_VER not null;

alter table CONFIGS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_CONFIG_OPT_LOCK_VER not null;

alter table COMMANDS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_CMD_OPT_LOCK_VER not null;

alter table PROCESSES
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_PS_OPT_LOCK_VER not null;

alter table AUDITS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_AUDIT_OPT_LOCK_VER not null;

alter table CREDENTIALS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_CRD_OPT_LOCK_VER not null;

alter table USERS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_USER_OPT_LOCK_VER not null;

alter table USER_ROLES
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_UR_OPT_LOCK_VER not null;

alter table CLUSTERS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_CLUSTER_OPT_LOCK_VER not null;

alter table CONFIG_REVISIONS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_CR_OPT_LOCK_VER not null;

alter table CLIENT_CONFIGS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_CC_OPT_LOCK_VER not null;

alter table USER_SETTINGS
    add OPTIMISTIC_LOCK_VERSION number default 0 constraint NOT_NULL_US_OPT_LOCK_VER not null;
